/********************************************************************
 * FILE: object-list.h
 * AUTHOR: William Stafford Noble
 * CREATE DATE: May Day, 2006 (Alaska #8, SEA -> Newark)
 * PROJECT: META-MEME
 * COPYRIGHT: 2006, UW
 ********************************************************************/

#ifndef OBJECT_LIST_H
#define OBJECT_LIST_H

#include "string-list.h"


/*************************************************************************
 * Primary data structure.
 *************************************************************************/
typedef struct object_list_t OBJECT_LIST_T;

/*************************************************************************
 * Create an empty object list.
 *************************************************************************/
OBJECT_LIST_T* new_object_list();

/*************************************************************************
 * Store a object in a list.
 *************************************************************************/
void store_object
 (void*          object,
  STRING_LIST_T* key,
  OBJECT_LIST_T* an_object_list);

/*************************************************************************
 * Store a object in a list.
 *************************************************************************/
void* retrieve_object
 (STRING_LIST_T* key,
  OBJECT_LIST_T* an_object_list);

/*************************************************************************
 * Get the next object in a list; saves state.
 * First call retrieves first object; successive calls retrieve next ones.
 * Returns NULL if at end * of list.  
 * The next call after that will retrieve the first object again.
 *************************************************************************/
void* retrieve_next_object
 (OBJECT_LIST_T* an_object_list);

/*************************************************************************
 * Free dynamic memory used by a list of objects.
 *************************************************************************/
void free_object_list
(void (*free_object)(), // Function to free objects in the list.
 OBJECT_LIST_T* a_list);

#endif

/*
 * Local Variables:
 * mode: c
 * c-basic-offset: 2
 * End:
 */
