/*************************************************************************
 * FILE: qvalue.h
 * AUTHOR: William Stafford Noble
 * CREATE DATE: 13 November 2007
 * PROJECT: MEME
 * COPYRIGHT: 2007, UW
 * DESCRIPTION: q value calculation, a la Benjamini Hochberg
 *************************************************************************/
#ifndef QVALUE_H
#define QVALUE_H

#include "array.h"

/*************************************************************************
 * Convert a set of p-values to a set of q-values.  The p-values must
 * be in sorted (ascending) order.  This function replaces them with
 * the corresponding q-values.
 *************************************************************************/
void compute_qvalues
  (BOOLEAN_T compute_fdr,   // If true, only compute FDR, not q-value.
   ATYPE     pi_zero,       // Percentage of incorrect targets.
   int       total_values,  // Total number of values.
   ARRAY_T*  pvalues);

#endif
